# all files / ol/format/ wmsgetfeatureinfo.js

96.43% Statements 54/56
81.82% Branches 18/22
50% Functions 3/6
96.43% Lines 54/56

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    1691×

    1×
    1×
    1×
    1×
    1×
    1×

    1×

    8×

    8×

    8×

    8×

    8×

    1×

    1×

    1×

    1×
    8×
    8×

    8×
    8×

    8×
    7×
    23×
    23×
    12×

    11×

    11×
    11×

    11×
    3×

    8×

    8×
    8×

    8×
    8×

    8×

    8×
    8×

    8×
    8×

    8×
    1×

    1×
    1×

    8×

    1×

    1×
    8×
    8×

    8×

    1×

    1×

    1×
     goog.provide('ol.format.WMSGetFeatureInfo');

    goog.require('ol');
    goog.require('ol.array');
    goog.require('ol.format.GML2');
    goog.require('ol.format.XMLFeature');
    goog.require('ol.obj');
    goog.require('ol.xml');

    /**
     * @classdesc
     * Format for reading WMSGetFeatureInfo format. It uses
     * {@link ol.format.GML2} to read features.
     *
     * @constructor
     * @extends {ol.format.XMLFeature}
     * @param {olx.format.WMSGetFeatureInfoOptions=} opt_options Options.
     * @api
     */
    ol.format.WMSGetFeatureInfo = function(opt_options) {

      var options = opt_options ? opt_options : {};

      /**
       * @private
       * @type {string}
       */
      this.featureNS_ = 'http://mapserver.gis.umn.edu/mapserver';

      /**
       * @private
       * @type {ol.format.GML2}
       */
      this.gmlFormat_ = new ol.format.GML2();

      /**
       * @private
       * @type {Array.<string>}
       */
      this.layers_ = options.layers ? options.layers : null;

      ol.format.XMLFeature.call(this);
    };
    ol.inherits(ol.format.WMSGetFeatureInfo, ol.format.XMLFeature);

    /**
     * @const
     * @type {string}
     * @private
     */
    ol.format.WMSGetFeatureInfo.featureIdentifier_ = '_feature';

    /**
     * @const
     * @type {string}
     * @private
     */
    ol.format.WMSGetFeatureInfo.layerIdentifier_ = '_layer';

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @return {Array.<ol.Feature>} Features.
     * @private
     */
    ol.format.WMSGetFeatureInfo.prototype.readFeatures_ = function(node, objectStack) {
      node.setAttribute('namespaceURI', this.featureNS_);
      var localName = node.localName;
      /** @type {Array.<ol.Feature>} */
      var features = [];
      Iif (node.childNodes.length === 0) {
        return features;
      }
      if (localName == 'msGMLOutput') {
        for (var i = 0, ii = node.childNodes.length; i < ii; i++) {
          var layer = node.childNodes[i];
          if (layer.nodeType !== Node.ELEMENT_NODE) {
            continue;
          }
          var context = objectStack[0];

          var toRemove = ol.format.WMSGetFeatureInfo.layerIdentifier_;
          var layerName = layer.localName.replace(toRemove, '');

          if (this.layers_ && !ol.array.includes(this.layers_, layerName)) {
            continue;
          }

          var featureType = layerName +
              ol.format.WMSGetFeatureInfo.featureIdentifier_;

          context['featureType'] = featureType;
          context['featureNS'] = this.featureNS_;

          var parsers = {};
          parsers[featureType] = ol.xml.makeArrayPusher(
              this.gmlFormat_.readFeatureElement, this.gmlFormat_);
          var parsersNS = ol.xml.makeStructureNS(
              [context['featureNS'], null], parsers);
          layer.setAttribute('namespaceURI', this.featureNS_);
          var layerFeatures = ol.xml.pushParseAndPop(
              [], parsersNS, layer, objectStack, this.gmlFormat_);
          Eif (layerFeatures) {
            ol.array.extend(features, layerFeatures);
          }
        }
      }
      if (localName == 'FeatureCollection') {
        var gmlFeatures = ol.xml.pushParseAndPop([],
            this.gmlFormat_.FEATURE_COLLECTION_PARSERS, node,
            [{}], this.gmlFormat_);
        Eif (gmlFeatures) {
          features = gmlFeatures;
        }
      }
      return features;
    };

    /**
     * Read all features from a WMSGetFeatureInfo response.
     *
     * @function
     * @param {Document|Node|Object|string} source Source.
     * @param {olx.format.ReadOptions=} opt_options Options.
     * @return {Array.<ol.Feature>} Features.
     * @api
     */
    ol.format.WMSGetFeatureInfo.prototype.readFeatures;

    /**
     * @inheritDoc
     */
    ol.format.WMSGetFeatureInfo.prototype.readFeaturesFromNode = function(node, opt_options) {
      var options = {};
      Iif (opt_options) {
        ol.obj.assign(options, this.getReadOptions(node, opt_options));
      }
      return this.readFeatures_(node, [options]);
    };

    /**
     * Not implemented.
     * @inheritDoc
     */
    ol.format.WMSGetFeatureInfo.prototype.writeFeatureNode = function(feature, opt_options) {};

    /**
     * Not implemented.
     * @inheritDoc
     */
    ol.format.WMSGetFeatureInfo.prototype.writeFeaturesNode = function(features, opt_options) {};

    /**
     * Not implemented.
     * @inheritDoc
     */
    ol.format.WMSGetFeatureInfo.prototype.writeGeometryNode = function(geometry, opt_options) {};